Versionsverlauf
===============

## [Noch nicht veröffentlicht]

- derzeit keine Änderungen

## [Version 3.10.0] - 2020-10-26

### Neu

#### Einschränkung von Jobnummern

Die von der KEXTls vergebenen Jobnummern für Telegramme liegen gemäß TLS zwischen 1 und 255.
  
Für die KRI-2X/KRI-2b in NRW ist es erforderlich, dass jeder Client nur einen bestimmten (anpassbaren) Jobnummernbereich verwendet. 
Soll ein individueller Jobnummernbereich eingestellt werden, können die notwendigen Parameter über folgende Einträge bei der 
`atg.protokollEinstellungenStandard` des Anschlusspunkts für alle Verbindungen an diesem Anschlusspunkt eingestellt werden:

Name = `osi7.jobNummerMinimal`
Wert = 1–255, Defaultwert ist 1

Name = `osi7.jobNummerMaximal`
Wert = 1–255, Defaultwert ist 255

**WICHTIG**: Damit dieses Feature genutzt werden kann, müssen die SWE KExTlsOsi7 mindestens in der angegebenen Version verwendet werden:

- `de.bsvrz.kex.tls.osi7` ab Version 5.8.0 

Setzt den Featurewunsch [Einschränkung von Jobnummern - #12](https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi7/-/issues/12) um. 


#### RXTX-Bibliothek ersetzt

- Ersetzung der RXTX-Bibliothek durch das kompatible und weiter entwickelte NRJavaSerial

## [Version 3.9.7]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories
- Übernahme basiert auf den Quellen aus der Kernsoftware V3.9.6

## Version 3.9.6

- Stand 26.10.2011

- **Änderungen**
  Folgende Änderungen zu vorhergehenden Versionen wurden durchgeführt:

  - In der KEx-TLS Implementierung gibt es auf OSI-2 und OSI-3-Ebene neue Möglichkeiten zur Unterstützung von älteren TLS-Geräten. Diese können über die Parameter atg.protokollEinstellungenStandard und atg.protokollEinstellungenPrimary an den in der TLS-Versorgung definierten Anschlußpunkten bzw. Anschlußpunkt-Kommunikationspartnern online verändert werden. Dabei sind folgende Werte zu verwenden:

    - *OSI3-Routing unterdrücken.*
      Mit der Einstellung "osi3.reduzierungAufSteuerbyte" auf den Wert "ja" kann der OSI-3-Header beim Versand von Telegrammen auf das Steuerbyte reduziert werden. Defaultwert ist "nein".

    - *OSI3-Pointer inkrementieren.*
      Mit der Einstellung "osi3.pointerInkrementieren" auf den Wert "nein" besteht die Möglichkeit, festzulegen, dass der OSI-3 Pointer vor dem Versand nicht inkrementiert wird. Defaultwert ist "ja".

    - *OSI3-Routing beim Empfang spiegeln.*
      Mit der Einstellung "osi3.adressenSpiegeln" auf den Wert "ja" besteht die Möglichkeit, festzulegen, dass die OSI-3-Adresse eines vom KRI empfangenen Telegramms vor der weiteren Verarbeitung gespiegelt wird. Defaultwert ist "nein".

    - *Unterstützung von OSI-2 Adressen außerhalb des Bereichs von 1-199.*
      Mit der Einstellung "secondary.adressen200-254Akzeptieren" auf den Wert "ja" (nur am Anschlusspunkt in der Attributgruppe atg.protokollEinstellungenStandard) kann die (nach TLS vorgesehene) Einschränkung auf Secondary-Adressen im Bereich 1-199 außer Kraft gesetzt werden kann, d.h. dass Secondary-Adressen außerhalb des bisher vorgesehen Bereichs also auch Werte von 200 bis 254 verwendet werden können und dass das OSI-3 Routing entsprechend korrekt aufgelöst und zugeordnet wird. Defaultwert ist "nein".

- **Bugfixes**
  Folgende Probleme vorhergehender Versionen wurden behoben:

  - Die TC-57 Implementierung im KEx-TLS konnte sich in seltenen Fällen verklemmen, wenn die Modemsteuerungssignale ein unerwartetes Verhalten aufzeigten.

## Stand 07.09.2007

- **Änderungen**
  Folgende Änderungen zu vorhergehenden Versionen wurden durchgeführt:

  - Anpassung der Import-Anweisungen auf neue Packagestruktur der Kernsoftware

  - Anpassung der Packagestruktur entsprechend der Vorgaben des AK-VRZ

  - Erzeugung eines Distributionspaket entsprechend der Vorgaben des AK-VRZ

- **Neue Packagestruktur**

|Bisheriger Dateipfad 	                                |Neues Package                                  |Neues Distributionspaket |
|-------------------------------------------------------|-----------------------------------------------|-------------------------|
|kex 	                                                |-                                              |                         |
|kex/tls 	                                            |-                                              |                         |
|kex/tls/longtelegram 	                                |de.bsvrz.kex.tls.osi2osi3.longtelegram         |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/longtelegram/LongTelegramType.java 	        |de.bsvrz.kex.tls.osi2osi3.longtelegram         |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/longtelegram/Osi7LongTelegramRecombine.java 	|de.bsvrz.kex.tls.osi2osi3.longtelegram         |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/longtelegram/Osi7LongTelegramSegment.java 	    |de.bsvrz.kex.tls.osi2osi3.longtelegram         |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2 	                                        |-                                              |                         |
|kex/tls/osi2/AbstractDataLinkLayer.java 	            |de.bsvrz.kex.tls.osi2osi3.osi2.api             |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/DataLinkLayer.java                        |de.bsvrz.kex.tls.osi2osi3.osi2.api             |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/DataLinkLayerEvent.java                   |de.bsvrz.kex.tls.osi2osi3.osi2.api             |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/DataLinkLayerListener.java                |de.bsvrz.kex.tls.osi2osi3.osi2.api             |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/LinkState.java                            |de.bsvrz.kex.tls.osi2osi3.osi2.api 	        |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/PrintingDataLinkLayerListener.java 	    |de.bsvrz.kex.tls.osi2osi3.osi2.api 	        |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57 	                                    |-                                              |                         |
|kex/tls/osi2/tc57/AbstractTc57.java 	                |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/DefaultProperties.java 	            |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/Primary.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/PrimaryFrame.java 	                |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/SecondaryFrame.java 	                |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/SerialPortControl.java 	            |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/Tc57Frame.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi2.tc57primary 	|de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/tc57/Wiretapper.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi2.tc57listen 	    |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/wancom 	                                |de.bsvrz.kex.tls.osi2osi3.osi2.wancom          |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/wancom/Client.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi2.wancom          |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/wancom/DefaultProperties.java          	|de.bsvrz.kex.tls.osi2osi3.osi2.wancom          |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/wancom/ProtocolState.java                 |de.bsvrz.kex.tls.osi2osi3.osi2.wancom          |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi2/wancom/WanCom.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi2.wancom          |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3 	                                        |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3/DestinationUnreachableException.java 	    |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3/NetworkLayer.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3/NetworkLayerListener.java 	            |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3/TlsNetworkInitializer.java 	            |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|kex/tls/osi3/TlsNetworkLayer.java 	                    |de.bsvrz.kex.tls.osi2osi3.osi3                 |de.bsvrz.kex.tls.osi2osi3|
|sys 	                                                |-                                              |                         |
|sys/funclib                                            |-                                              |                         |
|sys/funclib/properties 	                            |de.bsvrz.kex.tls.osi2osi3.properties           |de.bsvrz.kex.tls.osi2osi3|
|sys/funclib/properties/PropertyConsultant.java 	    |de.bsvrz.kex.tls.osi2osi3.properties           |de.bsvrz.kex.tls.osi2osi3|
|sys/funclib/properties/PropertyQueryInterface.java 	|de.bsvrz.kex.tls.osi2osi3.properties           |de.bsvrz.kex.tls.osi2osi3|




[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3/compare/v3.10.0...HEAD
[Version 3.10.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3/compare/v3.9.7...v3.10.0
[Version 3.9.7]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.kex.tls.osi2osi3/compare/v3.9.6...v3.9.7
